function selectLoad() {
	var now = new Date();
	var m = now.getMonth();
	var y = now.getYear();
	if(y < 1000)
		y += 1900;

	scegliCitta();
    document.calendar_control.month.selectedIndex = sel.mese-1;
	document.calendar_control.yr.value = sel.anno;
	doCal(sel.mese-1, sel.anno);
}

function selectCurrent() {
	var now = new Date();
	var y = now.getYear();
	var m = now.getMonth();
	if(y < 1000)
		y += 1900;

    sel.setData(now);
	document.calendar_control.month.selectedIndex = m;
	document.calendar_control.yr.value = y;
	doCal(m, y);
}

function selectNext() {
	var y = parseInt(document.calendar_control.yr.value);
	var m = document.calendar_control.month.selectedIndex;

	if(m < 11)
		m++;
	else {
		m = 0;
		y++;
	}

	document.calendar_control.month.selectedIndex = m;
	document.calendar_control.yr.value = y;
	doCal(m, y);
}

function selectPrev() {
	var y = parseInt(document.calendar_control.yr.value);
	var m = document.calendar_control.month.selectedIndex;

	if(m > 0)
		m -= 1;
	else {
		m = 11;
		y -= 1;
	}

	document.calendar_control.month.selectedIndex = m;
	document.calendar_control.yr.value = y;
	doCal(m, y);
}

function selectNextYear(num) {
	var y = parseInt(document.calendar_control.yr.value);
	var m = document.calendar_control.month.selectedIndex;
	y += num;
	document.calendar_control.yr.value = y;
	doCal(m, y);
}

function selectPrevYear(num) {
	var y = parseInt(document.calendar_control.yr.value);
	var m = document.calendar_control.month.selectedIndex;
	y -= num;
	document.calendar_control.yr.value = y;
	doCal(m, y);
}

function scegliCitta() {
	var idCitta = document.calendar_control.citta.selectedIndex;
	orari = orariDi(idCitta);
}

function selectForm(form) {
	var y = parseInt(form.yr.value);
	var m = form.month.selectedIndex;
	doCal(m, y);
}

function doCal(month, year) {
    $("td.giornata").off();
	var ret = calendar(month, year);
	var result = BuildLuachHTML(ret);
    $('#luach').html(result);
    caricaOrari();
    $("td.giornata").click(function(){
        sel.setData(new Date ($(this).data("anno"),$(this).data("mese")-1,$(this).data("giorno")) );
        caricaOrari();
        $("td.giornata").removeClass("selected");
        $(this).addClass("selected");
    });
}

function calendar(selM, selY) {
	var m = selM + 1;
	var y = selY;
	var d = civMonthLength(m, y);
	var firstOfMonth = new Date (y, selM, 1);
	var startPos = firstOfMonth.getDay() + 1;
	var retVal = new Object();
	retVal[1] = startPos;
	retVal[2] = d;
	retVal[3] = m;
	retVal[4] = y;
	return (retVal);
}

function BuildLuachHTML(parms)  {
	var hdrSize = "+2";				// size of tables header font
	var border = 2;					// 3D height of table's border
	var cellspacing = 4;			// width of table's border
	var hdrHeight = 50;				// height of the table's header cell
	var dayCellHeight = 25;			// height of cells containing days of the week
	var dayColor = "darkred";		// color of font representing week days
	var hebColor = "#0564c4";		// color of font representing Heb date
	var civColor = "#990000";		// color of font representing Civ date
	var cellWidth  = 90;			// width of columns in table
	var cellHeight = 70;			// height of day cells calendar
	var hebDate;
	var hebDay;
	var now = new Date();
	var tday = now.getDate();
	var tmonth = now.getMonth();
	var tyear = now.getYear();
	if(tyear < 1000)
		tyear += 1900;
	var cMonth = parms[3];
	var cYear = parms[4];
	var monthName = civMonth[cMonth];
	var lastDate = civMonthLength(cMonth, cYear);
	var hm;
	var hMonth;
	var hYear;
    
    if (sel.mese != cMonth || sel.anno != cYear){ sel.setData(new Date (cYear,cMonth-1,1) ); }

	// get starting Heb month in civil month
	hebDate = civ2heb(1, cMonth, cYear);
	hmS = hebDate.substring(hebDate.indexOf(' ')+1, hebDate.length);
	hMonth = eval(hmS.substring(0, hmS.indexOf(' ')));
	hYear = hmS.substring(hmS.indexOf(' ')+1, hmS.length);
	var start = hebMonth[hMonth+1] + ' ' + hYear;

	// get ending Heb month in civil month
	hebDate = civ2heb(lastDate, cMonth, cYear);
	hmE = hebDate.substring(hebDate.indexOf(' ')+1, hebDate.length);
	hMonth = eval(hmE.substring(0, hmE.indexOf(' ')));
	hYear = hmE.substring(hmE.indexOf(' ')+1, hmE.length);
	var end = hebMonth[hMonth+1] + ' ' + hYear;

	var hebSpan;
	// check if start and end Heb months are the same
	if(hmS == hmE)
		hebSpan = start;
	else
		hebSpan = start + ' / ' + end

    var result = '';
    result += '<center><br>';

	// set up our table structure
	result += '<TABLE style="background:#FAF2DD;table-layout: fixed;" BORDER=' + border + ' CELLSPACING=' + cellspacing + '>';		// table settings
	result +=	 '<TH COLSPAN=7 HEIGHT=' + hdrHeight + ' align="center">';		// create table header cell
	result +=		'<FONT face="Arial" COLOR="' + civColor + '" SIZE=' + hdrSize + '>';	// set font for table header
	result +=			monthName + ' ' + cYear;
	result +=		'</FONT>';		// close table header's font settings
	result +=		'<FONT face="Arial"COLOR="' + hebColor + '" SIZE=' + '+1' + '>'; // set font for table header
	result +=			'&nbsp&nbsp ' + hebSpan;
	result +=		'</FONT>'; // close table header's font settings
	result +=	 '</TH>'; // close header cell

	// variables to hold constant settings
	var openCol = '<TD WIDTH=' + cellWidth + ' HEIGHT=' + dayCellHeight + '>';
	openCol += '<FONT face="Arial" COLOR="' + dayColor + '">';
	var closeCol = '</FONT></TD>';

	// create first row of table to set column width and specify week day
	result += '<TR ALIGN="center" VALIGN="center">';
	for (var dayNum = 1; dayNum < 8; ++dayNum) {
	        result += openCol + weekDay[dayNum] + closeCol;
	}
	result += '</TR>';
 
    var cell = 1
    var cDay = 1
    var row;
    for (row = 1; row <= 6; row++) {
        result+='<TR VALIGN="top">'
        for (col = 1; col <= 7; col++)  {

			// convert civil date to hebrew
			hebDate = civ2heb(cDay, cMonth, cYear);
			hebDay = eval(hebDate.substring(0, hebDate.indexOf(' ')));
            
            // convert civil date to hebrew again :-)
            //var dh     = GregToHeb(new Date(cYear,cMonth-1,cDay));

			var hm = hebDate.substring(hebDate.indexOf(' ')+1, hebDate.length);
			var hMonth = eval(hm.substring(0, hm.indexOf(' ')));

	        if (cell < parms[1])
				result += '<TD></TD>';
	        else {
                
                var nome_parasha = "";
                var shabbatSegnalato = '';
                var w = new Date(cYear,cMonth-1,cDay).getDay();
                if (w == 6 ) {
                    nome_parasha = parasha (cDay, cMonth, cYear);
                    shabbatSegnalato = isShabbatSegnalato(cDay, cMonth, cYear);
                    if (nome_parasha == 'Beshallach') {shabbatSegnalato = 'Shabbat Shira';}
                }
                var roshChodesh = isRoshChodesh(cDay, cMonth, cYear);
                var shabbatMevarechim = isShabbatMevarechim(cDay, cMonth, cYear);
                var omer = isOmer(cDay, cMonth, cYear);
				var feste = festeH(cDay, cMonth, cYear);
				var otherClass = '';
                var bg = '';
		        if((cDay == sel.giorno) && (parms[3] == sel.mese) && (parms[4] == sel.anno)){
                    otherClass = ' selected';
                    caricaOrari();
                }    
		        if((cDay == tday) && (parms[3] == (tmonth+1)) && (parms[4] == tyear)){
					bg = 'bgColor=#FFFFFF';
                }    
				else if (isYamimNoraim(cDay, cMonth, cYear))               {bg = 'bgColor=#FF8484';}                         // colore yamim noraim
                else if (isFestaSolenne(cDay, cMonth, cYear))              {bg = 'bgColor=#FF9966';}                         // colore festa solenne
                else if (isMezzaFesta(cDay, cMonth, cYear))                {bg = 'bgColor=#FFC2A3';}                         // colore mezza festa
                else if (isFestaPostbiblica(cDay, cMonth, cYear))          {bg = 'bgColor=#FFFF99';}                         // colore festa postbiblica
                else if (isDigiunoPostbiblico(cDay, cMonth, cYear))        {bg = 'bgColor=#D6FFAD';}                         // colore digiuno postbiblico
				else if (roshChodesh)                                      {bg = 'bgColor=#ADD6FF';}                         // colore rosh chodesh

				// assemble the contents of our day cell
				result += '<td class="giornata'+ otherClass +'" align="center" ' + bg + ' data-giorno="'+ cDay +'" data-mese="'+ cMonth +'" data-anno="'+ cYear +'" data-w="'+ w +'" tabindex="'+((row-1)*7+col)+'">';
                result += '<div class="myclass">';
				result +=   '<table BORDER=0 COLS=2 WIDTH=' + cellWidth + ' HEIGHT=' + dayCellHeight + ' >';
				result +=     '<tr>';
				result +=       '<td>';
				result +=         '<font face="Arial" COLOR="' + civColor + '">';
				result +=           cDay;
				result +=         '</font>';
				result +=       '</td>';
				result +=       '<td>';
				result +=         '<font face="Arial" COLOR="' + hebColor + '">';
				result +=           '<div align=right>' + hebDay + '</div>';
				result +=         '</font>';
				result +=       '</td>';
				result +=     '</tr>';
				result +=   '</table>';
				result +=   '<font face="Arial" size=-2>'
				var note = "";
                if (feste != ""){note += feste;}
				if (nome_parasha != "")     {if(note!=""){note+='<br />';}note += nome_parasha;}
                if (roshChodesh)            {if(note!=""){note+='<br />';}note += 'Rosh Chodesh';}
                if (shabbatSegnalato != '' ){if(note!=""){note+='<br />';}note += shabbatSegnalato;}                
                if (omer)                   {if(note!=""){note+='<br />';}note += omer + '° Omer';}
                if (shabbatMevarechim)      {if(note!=""){note+='<br />';}note += 'Sh. Mevarechim';}
                result += note;
				result +=   '</font>'
                result +=   '</div>'
				result += '</td>';

		        cDay++
            }

            if (cDay <= lastDate)
                cell++
            else
                break;
        }

        result += '</TR>'
        if(cDay > parms[2])
                break;
    }

    result += '</table>';
    




    result += '</center>';
    //result += '</body></html>'
    return result;
}
